#ifndef lint
static const char rcsid[] =
	"$Id: settitle.c,v 1.3 2002/04/20 14:53:53 andrew Exp $";
#endif

#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sysexits.h>

#include "settitle.h"

/* OS portability */
#ifndef HAVE_PROGNAME
#include "progname.h"
#endif

static void usage(void);

int main(int argc, char *argv[]) {
	int c,
		set_window,
		set_icon;

	/* initialise progname for later possible use by usage */
	setprogname(argv[0]);

	/* note we haven't done anything so we can call usage later if we never
	 * do anything */
	set_icon = set_window = 0;

	/* process switches */
	while ((c = getopt(argc, argv, "i:t:")) != -1) {
		switch (c) {
			case 'i':
				/* set icon name */
				if (set_icon) {
					usage();
				} else {
					set_icon = 1;
					(void)printf("%c]1;%s%c", ESC, optarg, BEL);
				}
				break;
			case 't':
				/* set window title */
				if (set_window) {
					usage();
				} else {
					set_window = 1;
					(void)printf("%c]2;%s%c", ESC, optarg, BEL);
				}
				break;
			case '?':
			default:
				usage();
				break;
		}
	}
	argc -= optind;
	argv += optind;

	/* if there are any arguments specified then we assume it's the title
	 * for both window and icon */
	if (argc == 1) {
		/* set both titles */
		if (set_icon || set_window) {
			/* already set one */
			usage();
		} else {
			set_icon = set_window = 1;
			(void)printf("%c]0;%s%c", ESC, argv[0], BEL);
		}
	} else if (argc != 0) {
		/* specified more than one title */
		usage();
	}

	/* see if we have done anything */
	if (! set_icon && ! set_window) {
		/* we haven't so give an error message */
		usage();
	}

	return 0;
}

int control(int c) {

	return(c - '@');
}

static void usage(void)  {

	fprintf(stderr, "usage: %s [-i icon_title] [-t window_title] [both_title]\n", getprogname());
	exit(EX_USAGE);
}
